LIGHT OJ 1259 - Goldbach`s Conjecture(素数筛选)

简介:

传送门


1259 - Goldbach`s Conjecture
Time Limit: 2 second(s) Memory Limit: 32 MB

Goldbach's conjecture is one of the oldest unsolved problems in number theory and in all of mathematics. It states:

Every even integer, greater than 2, can be expressed as the sum of two primes [1].

Now your task is to check whether this conjecture holds for integers up to 107.

Input

Input starts with an integer T (≤ 300), denoting the number of test cases.

Each case starts with a line containing an integer n (4 ≤ n ≤ 107, n is even).

Output

For each case, print the case number and the number of ways you can express n as sum of two primes. To be more specific, we want to find the number of (a, b)where

1)      Both a and b are prime

2)      a + b = n

3)      a ≤ b

Sample Input

Output for Sample Input

2

6

4

Case 1: 1

Case 2: 1

Note

1.      An integer is said to be prime, if it is divisible by exactly two different integers. First few primes are 2, 3, 5, 7, 11, 13, ...



题目大意:

首先给定T组数据,让你求的是,一个>=4的偶数拆分成两个素数之和的形式能够有几对。


样例解释:

当 n = 6时,6 = 3 + 3只有一对,

当 n=10时,10 = 5 + 5 = 3 + 7(7+3)有两对所以输出3


解题思路:

就是一个素数筛,没什么说的感觉(我还错了几次),当时也不知道是怎么回事,有可能是编译器坏了,明明一样的代码,在自己这就是不能过,但是交上去就能过,真是神了,需要注意的是素数筛的时候要记录素数的值,在主函数中用到,不能直接 n/2算,会超时,最后因为我们算的是对数所以要除以2,然后再判断 n/2是不是素数,如果是+1

不是不用变,上代码:


My Code:

#include <iostream>
#include <cstring>
#include <cstdio>
using namespace std;
const int MAXN = 1e7+5;
const int M = 1e6+5;
typedef long long LL;
int p[M];
bool prime[MAXN];
int cnt = 0;
void isprime()
{
    cnt = 0;
    memset(prime, true, sizeof(prime));
    prime[0] = prime[1] = false;
    for(LL i=2; i<MAXN; i++)
    {
        if(prime[i])
        {
            p[cnt++] = i;
            for(LL j=i*i; j<MAXN; j+=i)
                prime[j] = false;
        }
    }
}
int main()
{
    isprime();
    int T,n;
    scanf("%d",&T);
    for(int cas=1; cas<=T; cas++)
    {
        scanf("%d",&n);
        int sum = 0;
        for(int i=0; i<cnt&&p[i]<=n; i++)
            if(prime[n-p[i]])
                sum++;
        sum >>= 1;
        if(prime[n/2])
            sum++;
        printf("Case %d: %d\n",cas,sum);
    }
    return 0;
}




目录
相关文章
|
6月前
light oj 1159 - Batman LCS
学过简单动态规划的人应该对最长公共子序列的问题很熟悉了,这道题只不过多加了一条字符串变成三条了,还记得,只要把状态变成三维的即可。
16 0
|
6月前
Light oj 1112 - Curious Robin Hood(树状数组)
有n个数,有m组操作,1 i表示将第i个数先输出,然后置0, 2 i v 表示给第i个数加上v, 3 i j 表示求i 到 j 的和,注意,这里数组是从0开始的,而我们构造的树状数组是从1 开始的,使用在程序中要进行一定的处理。
23 0
|
6月前
|
机器学习/深度学习
light oj 1005 - Rooks(组合数学)
组合数学解法 现在n行中选出m行,C(n,m),再在n列中选出m列随便放A(n,m),答案为C(n,m)*A(n,m)。
20 0
|
6月前
|
算法
light oj 1047 - Neighbor House 动态规划
动态规划,这个和刘汝佳算法竞赛入门经典P158的数字三角形有些相似,不过是求最小的值,而且有些限制,每次走到点和上次走的点不在同一列。
17 0
|
6月前
light oj 1231-1232 - 1233- Coin Change 背包
暂时到半懂不懂也没办法讲明白,就不误人子弟了,直接贴代码了。
20 0
|
6月前
|
机器学习/深度学习 存储
light oj 1011 - Marriage Ceremonies (状态压缩+记忆化搜索)
light oj 1011 - Marriage Ceremonies (状态压缩+记忆化搜索)
25 0
|
8月前
UVa837 - Light and Transparencies(排序)
UVa837 - Light and Transparencies(排序)
35 0
POJ-Silver Cow Party (最短路)
POJ-Silver Cow Party (最短路)
72 0
hdu 1312 Red and Black(BFS)
hdu 1312 Red and Black(BFS)
118 0